#!/bin/bash
############################################################
### Ultima modificacion: 16/08/06
###
### recordando que los paquetes abajo
### indicados son para una maquina
### si va a utilizar un servidor de e-mails y de ladp, por ejemplo, 
### de otra mquina, algunos paquetes no eran necesarios.
### depende de cada implementacin.
### Lea todo este script y ajustelo a sus necesidades.
############################################################


### Instala todos los paquetes y dependencias necesarias al Expresso.
### Ese proceso es un poco demorado y exige que los repositorios online
### estn configurados.
### Descomente esta linea para resolver todas las dependencias de Expresso.
yast -i apache2 apache2-prefork apache2-mod_php4 apache2-mod_perl openssl openssl-devel php4 php4-devel php4-session php4-gd php4-imap php4-ldap php4-pgsql php4-fastcgi php4-mbstring postgresql postgresql-server openldap2 openldap2-client openldap2-devel openldap2-back-meta openldap2-back-perl db42 cyrus-imapd cyrus-sasl-devel cyrus-sasl cyrus-sasl-saslauthd postfix vim perl-Cyrus-IMAP imap-lib perl-Parse-RecDescent perl-TermReadKey perl-TermReadLine-Gnu perl-MLDBM perl-MLDBM-Sync perl-ldap perl-Apache-AuthNetLDAP perl-libwww-perl perl-HTML-Parser perl-Tie-IxHash perl-HTML-Tagset perl-Convert-ASN1 readline-devel readline zip uzip

echo -e "\n\n\n\n\n\n##########################################################\n"
echo -e "BIENVENIDO A LA INSTALACION DE EXPRESSO LIVRE\n"
echo -e "Este script fue echo para correr en sistema Linux Suse 10.0.\n"
echo -e "Cualquier otro sistema puede exigir modificaciones en este script."
echo -e "\n##########################################################\n"
echo -e "Escriba la misma  contrasea de LDAP."
echo -ne "Esta  contrasea sera utilizada para el usuario expresso-admin.\n"
echo " contrasea: "
read LDAP_PWD
echo -e "\nEscriba su organizacin, ejemplo: soporte: "
read ORG
echo -e "\nEscriba su dominio, ejemplo: netcom.inf.br: "
read DOMAIN
echo -e "\nEscriba su  dc para el LDAP, ejemplo: dc=netcom,dc=inf,dc=br: "
read DC_LDAP

echo "##############################################"
echo "###  DEFINIENDO LAS VARIABLES ..."
echo "##############################################"

LDAP_DN="$DC_LDAP"
NOME=`echo $DOMAIN | awk -F . '{print $1}'`
LDAP_PWD_MD5=`slappasswd -v -s $LDAP_PWD -h {MD5}`
LDAP_PWD_MD5=`php ./arqs-conf-suse/regexp.php $LDAP_PWD_MD5`
HEADER_PWD=`php ./arqs-conf-suse/pass.php $LDAP_PWD`


echo "##############################################"
echo "###  PREPARANDO  POSTGRESQL ..."
echo "##############################################"

### Prepara la base de datos de Expresso basada en informaciones actuales.
### No necesita ser ejecutado si requiere hacerlo manualmente la primera vez que entre a expresso.
#sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/LDAP_PWD/$LDAP_PWD/g" -e "s/DOMAIN/$DOMAIN/g" -e "s/ORG/$ORG/g" ./arqs-conf-suse/expresso.dump > /tmp/expresso.dump

### Esto borrara cualquier informacion que tenga en postgresql.
### Comente estas lineas en caso de que tnga  base que no puede ser borrada
### Caso descomente esas lineas, pode comentar el dropdb abajo.
#rcpostgresql stop
#rm -Rf /var/lib/pgsql/data/
#rcpostgresql start

### Copia los archivos de configuracion de  postgresql  para  Expresso.
cp /var/lib/pgsql/data/pg_hba.conf /var/lib/data/pgsql/pg_hba.conf.bkpexpresso
cp ./arqs-conf-suse/var/lib/pgsql/data/pg_hba.conf /var/lib/pgsql/data/
cp /var/lib/pgsql/data/postgresql.conf /var/lib/data/pgsql/postgresql.conf.bkpexpresso
cp ./arqs-conf-suse/var/lib/pgsql/data/postgresql.conf /var/lib/pgsql/data/

### Confirma si postgresql est corriendo.
rcpostgresql stop
sleep 3
rcpostgresql start

###Borra la base de datos "expresso" para no dar problema en caso de que ya exista.
dropdb -U postgres expresso

### Crea la base de datos  "expresso" en formato latin1.
createdb -U postgres -E latin1 expresso

### Importa las tablas generadas para la base "expresso".
### Esto puede ser realizada por expresso cuando ingrese por primera vez.
#psql -U postgres expresso < /tmp/expresso.dump
#rcpostgresql restart
#rm /tmp/expresso.dump


echo "##############################################"
echo "###  PREPARANDO  APACHE ..."
echo "##############################################"

### A linea abajo es solamente para  Debian. No es correspondiente en Suse.
#apache2-ssl-certificate;
a2enmod rewrite;

### Se ya existe una instalacion de expresso en apache,  ser removida.
rm -Rf /srv/www/htdocs/expresso/

### Copia los archivos de expresso para o apache. Coloca los permisos correctos.
cp -R -p ../../../expresso/ /srv/www/htdocs/
chown -R wwwrun:www /srv/www/htdocs/expresso/

### Intercambia los archivos de configuracion de apache por los de  Expresso.
cp /etc/apache2/httpd.conf /etc/apache2/httpd.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/httpd.conf /etc/apache2/

cp /etc/apache2/server-tuning.conf /etc/apache2/server-tuning.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/server-tuning.conf /etc/apache2/

cp ./arqs-conf-suse/etc/apache2/vhosts.d/expresso.conf /etc/apache2/vhosts.d/

cp /etc/apache2/sysconfig.d/global.conf /etc/apache2/sysconfig.d/global.conf.bkpexpresso
cp ./arqs-conf-suse/etc/apache2/sysconfig.d/global.conf /etc/apache2/sysconfig.d/

### Cambia el archivo de configuracion de PHP con las exigencias de Expresso.
cp /etc/php.ini /etc/php.ini.bkpexpresso
cp ./arqs-conf-suse/etc/php4/apache2/php.ini /etc/

### Borra la carpeta  php_sessions para evitar problemas, caso de que ya  exista. Crea nuevamente con los permisos.
rm -Rf /php_sessions/
mkdir /php_sessions/
chmod -R 777 /php_sessions/

### Reinicia o apache.
rcapache2 restart


echo "##############################################"
echo "### PREPARANDO OOPENLDAP ..."
echo "##############################################"

### Genera el archivo de configuracion  de Servidor LDAP personalizado y lo sustituye.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/LDAP_PWD/$LDAP_PWD/g" ./arqs-conf-suse/etc/openldap/slapd.conf > /etc/openldap/slapd.conf

### Copia los schemas usados por Expresso.
cp ./arqs-conf-suse/etc/openldap/schema/* /etc/openldap/schema/
rcldap stop

### Genera a base por defecto de LDAP para  expresso.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/NOME/$NOME/g" -e "s/ORG/$ORG/g" -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/expresso.ldif > /tmp/expresso.ldif

### Remove todas las entradas viejas de LDAP.
rm -Rf /var/lib/ldap/*
rcldap start

### Importa a base LDAP.
rcldap stop
slapadd -v -f /etc/openldap/slapd.conf -l /tmp/expresso.ldif
rcldap start
#rm /tmp/expresso.ldif


echo "##############################################"
echo "### PREPARANDO O SASL ..."
echo "##############################################"

### Adapta  SASL para  Expresso.
sed -e "s/LDAP_DN/$LDAP_DN/g" ./arqs-conf-suse/etc/saslauthd.conf > /etc/saslauthd.conf
cp ./arqs-conf-suse/etc/default/saslauthd /etc/default/

### Reinicia  SASL.
rcsaslauthd restart

echo "##############################################"
echo "### PREPARANDO O CYRUS ..."
echo "##############################################"

### Copia archivo de configuracion  de IMAP. Cuotas estan deshabilitadas!!!
cp ./arqs-conf-suse/etc/imapd.conf /etc/

### Copia el ejecutable de cyrus adaptado a usuario expresso-admin. Solamente para login.
cp -p ./arqs-conf-suse/usr/bin/cyradm_expresso /usr/bin/

### Reinicia los servicios.
rccyrus restart
sleep 4

### Genera las carpetas  de IMAP para  el expresso-admin.
./arqs-conf-suse/cyrus.pl $LDAP_PWD


echo "##############################################"
echo "### PREPARANDO POSTFIX ..."
echo "##############################################"

### Genera el archivo expresso-dominios basado en el dominio informado.
sed -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/etc/postfix/expresso-dominios > /etc/postfix/expresso-dominios
postmap /etc/postfix/expresso-dominios

### Substituye  main.cf original por otro con  as informacin personalizada.
sed -e "s/LDAP_DN/$LDAP_DN/g" -e "s/DOMAIN/$DOMAIN/g" ./arqs-conf-suse/etc/postfix/main.cf > /etc/postfix/main.cf
cp ./arqs-conf-suse/etc/postfix/master.cf /etc/postfix/
rcpostfix restart

### Adiciona los usuarios "postfix" e "mail" al grupo "postdrop".
groupadd postdrop
useradd postfix
useradd mail


echo "##############################################"
echo "### PREPARANDO LA CARPETA HOME DE EXPRESSO ..."
echo "##############################################"

# imapsync & mkpasswd

### Crea, copia de los archivos necesarios para el y coloca los permisos adecuados.
mkdir /home/expressolivre
cp ./arqs-conf-suse/home/expressolivre/* /home/expressolivre/
chown -R wwwrun:www /home/expressolivre/

echo "##############################################"
echo "### PREPARANDO  HEADER_INC_PHP ..."
echo "##############################################"

##################
### ATENCION EN  Suse 10.0 + php4 existe un "else" en la linea 89 que da erroe. En Caso de pase por algo parecido,
### consulte o header.inc.php de lA carpets arqs-conf-suse para comparar la solucion.
##################
#sed -e "s/HEADER_PWD/$HEADER_PWD/g" ./arqs-conf-suse/header.inc.php > /srv/www/htdocs/expresso/header.inc.php
#chown wwwrun:www /srv/www/htdocs/expresso/header.inc.php

### Para garantizar la configuracion  manual do header_inc_php, este sera removido.
rm -f /srv/www/htdocs/expresso/header.inc.php

insserv apache2 ; insserv postgresql ; insserv saslauthd ; insserv cyrus ; insserv ldap ; insserv -r nscd 

echo "##############################################"
echo "### TERMINADAS AS ROTINAS DE INSTALACAO DO EXPRESSO!"
echo "###"
echo "### Confiirme en las salidas do script si todo ocorrio bien."
echo "###"
echo "### Instalador realizada en versin Debian por"
echo "### Joao Alfredo Knopik Junior "
echo "### jakjr@celepar.pr.gov.br"
echo "###"
echo "### Reeditado, adaptado ao Suse e comentado por"
echo "### Marcus Augustus Pereira Burghardt"
echo "### marcus@netcom.inf.br"
echo "###"
echo "##############################################"

